<script lang="ts">
	import Map from '../components/map.svelte'
	import RouteMeta from '../components/RouteMeta.svelte'
	import type { PageData } from './$types'

	interface Props {
		data: PageData;
	}

	let { data }: Props = $props();


	function calcTimeLeft() {
		if (!data.userRoute?.timeGoal) return
		return Math.round(
			(data.userRoute.timeGoal.getTime() - data.userRoute.timeStarted.getTime()) / (1000 * 60 * 60 * 24)
		)
	}
	let timeLeft = $derived(calcTimeLeft())
</script>

<div>
	<RouteMeta
		style="grid-area: meta"
		routeName={data.userRoute?.route.name}
		routeDistanceKM={data.userRoute?.route.lengthKM || 0}
		timeGoal={data.userRoute?.timeGoal.getTime() || 0}
		timeStarted={data.userRoute?.timeStarted.getTime() || 0}
		routeProgressKM={data.distanceM / 1000 || 0}
	/>
	<Map
		id="map"
		meterDistance={data.distanceM || 0.001}
		journeyLengthKM={data.userRoute?.route.lengthKM}
		journey={data.userRoute?.route?.geometry}
		markerPng={data.user?.avatar}
		otherMeterDistances={data.otherUsers}
		drawMarker={true}
		style="grid-area: map"
	/>
</div>

<style>
	div {
		display: grid;
		grid-template-rows: 6rem 1fr;
		grid-template-areas: 'meta' 'map';
		height: 100%;
	}
</style>
